xfstests: honor comments in the test group file
[xfstests-dev.git] / 094
1 #! /bin/bash
2 # FS QA Test No. 094
3 #
4 # Exercising the inheritable realtime inode bit.
5 #
6 #-----------------------------------------------------------------------
7 # Copyright (c) 2000-2005 Silicon Graphics, Inc.  All Rights Reserved.
8 #
9 # This program is free software; you can redistribute it and/or
10 # modify it under the terms of the GNU General Public License as
11 # published by the Free Software Foundation.
12 #
13 # This program is distributed in the hope that it would be useful,
14 # but WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
16 # GNU General Public License for more details.
17 #
18 # You should have received a copy of the GNU General Public License
19 # along with this program; if not, write the Free Software Foundation,
20 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
21 #
22 #-----------------------------------------------------------------------
23 #
24 # creator
25 owner=nathans@sgi.com
26
27 seq=`basename $0`
28 echo "QA output created by $seq"
29
30 here=`pwd`
31 tmp=/tmp/$$
32 status=1        # failure is the default!
33 trap "_cleanup; exit \$status" 0 1 2 3 15
34
35 _cleanup()
36 {
37     cd /
38     rm -f $tmp.*
39 }
40
41 # get standard environment, filters and checks
42 . ./common.rc
43 . ./common.filter
44
45 # real QA test starts here
46 _supported_fs xfs
47 _supported_os IRIX Linux
48 _require_realtime
49 _require_scratch
50 _require_command /usr/sbin/xfs_io
51
52 _filter_realtime_flag()
53 {
54         _test_inode_flag realtime $SCRATCH_MNT/testdir/$1
55         if [ $? -eq 0 ]; then
56                 echo "--r-- SCRATCH_MNT/testdir/$1"
57         else
58                 echo "----- SCRATCH_MNT/testdir/$1"
59         fi
60 }
61
62 _filter_rtinherit_flag()
63 {
64         _test_inode_flag rt-inherit $SCRATCH_MNT/testdir
65         if [ $? -eq 0 ]; then
66                 echo "--t-- SCRATCH_MNT/testdir"
67         else
68                 echo "----- SCRATCH_MNT/testdir"
69         fi
70 }
71
72 _create_scratch()
73 {
74         echo "*** mkfs"
75         if ! _scratch_mkfs_xfs >$tmp.out 2>&1
76         then
77                 cat $tmp.out
78                 echo "failed to mkfs $SCRATCH_DEV"
79                 exit 1
80         fi
81
82         echo "*** mount"
83         if ! _scratch_mount
84         then
85                 echo "failed to mount $SCRATCH_DEV"
86                 exit 1
87         fi
88 }
89
90 _create_scratch
91 mkdir $SCRATCH_MNT/testdir
92
93 # set inode attribute, create files below and check they're marked realtime
94 # unset inode attribute, create files below and check they're not realtime
95
96 echo "*** create directory with rtinherit"
97 $XFS_IO_PROG -r -c 'chattr +t' $SCRATCH_MNT/testdir
98 _filter_rtinherit_flag
99
100 echo "*** create child with inherited realtime"
101 touch $SCRATCH_MNT/testdir/real
102 _filter_realtime_flag real
103
104 echo "*** remove rtinherit from directory"
105 $XFS_IO_PROG -r -c 'chattr -t' $SCRATCH_MNT/testdir
106 _filter_rtinherit_flag
107
108 echo "*** create child without inherited realtime"
109 touch $SCRATCH_MNT/testdir/unreal
110 _filter_realtime_flag unreal
111
112 echo "*** done"
113
114 # success, all done
115 status=0
116 exit